//
//  SpeechHandler.m
//  SpeechTest
//
//  Created by Casey Fleser on 12/20/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "SpeechHandler.h"

@interface DebugSpeechSynthesizer : NSSpeechSynthesizer
@end

@implementation DebugSpeechSynthesizer

- (void) dealloc
{
	NSLog(@"DebugSpeechSynthesizer %@ dealloc'd", self);
	
	[super dealloc];
}

- (id) retain
{
	NSLog(@"DebugSpeechSynthesizer %@ retain %d", self, [self retainCount] + 1);

	return [super retain];
}

- (oneway void) release
{
	NSLog(@"DebugSpeechSynthesizer %@ release %d", self, [self retainCount] - 1);

	[super release];
}

@end

@implementation SpeechHandler

- (IBAction) speak: (id) inSender
{
	NSSpeechSynthesizer		*synthesizer = [[DebugSpeechSynthesizer alloc] initWithVoice: [NSSpeechSynthesizer defaultVoice]];
	
	if (synthesizer != nil) {
		[synthesizer setDelegate: self];
		[synthesizer startSpeakingString: [_speechText stringValue]];
	}
}

- (void) speechSynthesizer: (NSSpeechSynthesizer *) inSender
	didFinishSpeaking: (BOOL) inFinishedSpeaking
{
	NSLog(@"NSSpeechSynthesizer %@ finished", inSender);
	
	[inSender release];
}

@end
